#include "GenericTypeDefs.h"

// Clock frequency value.
#define CLOCK_FREQ			(20000000ul)	// Hz

// ENC28J60 I/O pins
#define ENC_CS_TRIS		(pd3.b1)
#define ENC_CS_IO		(p3.b1)

#define ENC_SPI_IF		sssr.rdrf

#define ENC_SSPRBUF		ssrdr
#define ENC_SSPTBUF		sstdr
#define ENC_SSPBUF		fixme

// MAC RAM definitions
#define RAMSIZE	8192ul		
#define TXSTART ((RAMSIZE-1ul) - (1ul+1514ul+7ul))
#define RXSTART	(0ul)						// Should be an even memory address; must be 0 for errata
#define	RXSTOP	((TXSTART-2ul) | 0x0001ul)	// Odd for errata workaround
#define RXSIZE	(RXSTOP-RXSTART+1ul)

#define BASE_TX_ADDR	(TXSTART + 1ul)
#define BASE_TCB_ADDR	(BASE_TX_ADDR + (1514ul+7ul))

typedef struct __attribute__((__packed__)) _MAC_ADDR
{
    BYTE v[6];
} MAC_ADDR;

typedef struct __attribute__((__packed__)) _APP_CONFIG 
{
	MAC_ADDR	MyMACAddr;
} APP_CONFIG;

extern APP_CONFIG AppConfig;
