#include <inttypes.h>
#include <string.h>
#include "bsp.h"
#include "led.h"
#include "spi.h"
#include "power.h"
#include "tty.h"
#include "eth-config.h"
#include "enc28j60.h"
#include "uip/uip.h"

unsigned char my_mac[] = 
  { 0x11, 0x22, 0x33, 0x33, 0x22, 0x11 };

Reset ()
{
}

static void
diag_ade (int channel)
{
  spi_power ();
  power_getreg (channel, 0x3f);
}

pm_appcall ()
{
}

pm_udp_appcall ()
{
}

static unsigned char mac_bcast[] = { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };
static char message[] = "00000000 This is a powermeter message!";

diag_ethernet ()
{
  int i, b;

  for (i=7; i>=0; i--)
    if (message[i] == '9')
      message[i] = '0';
    else
      {
	message[i] ++;
	break;
      }

  spi_ethernet ();

  memcpy (uip_buf, mac_bcast, 6);
  memcpy (uip_buf+6, my_mac, 6);
  uip_buf[12] = 0xff;
  uip_buf[13] = 0xff;
  memcpy (uip_buf+14, message, sizeof(message));

  cprintf("sending: ");
  cprintf("%x %x %x\n",
	  uip_buf, 6,
	  uip_buf+6, 6,
	  uip_buf+12, 2);
  enc28j60PacketSend (14+sizeof(message), uip_buf);
}

static char twiddlec[] = "\\|/-";
static int twiddlei = 0;
#define twiddle tty_putc (twiddlec[(++twiddlei)&3]); tty_putc(8);

check_ether_rx ()
{
  MAC_ADDR mac;
  BYTE type;

  spi_ethernet ();

  uip_len = enc28j60PacketReceive(UIP_BUFSIZE, uip_buf);
  if (uip_len == 0)
    {
      twiddle;
      return;
    }
  cprintf("uip_buf len %d\t", uip_len);
  cprintf("%x %x %x\n",
	  uip_buf, 6,
	  uip_buf+6, 6,
	  uip_buf+12, 2);
}

static void one_led(led)
{
  p6.b = led;
  wait_ms (50);
}

static unsigned char leds[] = { LED_GRN, LED_YEL, LED_BLU, LED_RED };

main()
{
  unsigned int i, j;
  pd6.b = 0x0f;

  tty_init ();

  tty_puts("\npowermeter ready!\n");

  p6.b = 0;

  spi_reset ();

  power_init ();

  spi_ethernet ();
  enc28j60Init ();

  while (1)
    {
      i++;

      one_led (leds[i%4]);

      diag_ade (i % 16);
      if (i % 16 == 15)
	diag_ethernet ();

      check_ether_rx ();
    }
}
