enum {
  WAVEFORM=1,
  AENERGY,
  RAENERGY,
  LAENERGY,
  VAENERGY,
  RVAENERGY,
  LVAENERGY,
  LVARENERGY,
  MODE,
  IRQEN,
  STATUS,
  RSTSTATUS,
  CH1OS,
  CH2OS,
  GAIN,
  PHCAL,
  APOS,
  WGAIN,
  WDIV,
  CFNUM,
  CFDEN,
  IRMS,
  VRMS,
  IRMSOS,
  VRMSOS,
  VAGAIN,
  VADIV,
  LINCYC,
  ZXTOUT,
  SAGCYC,
  SAGLVL,
  IPKLVL,
  VPKLVL,
  IPEAK,
  RSTIPEAK,
  VPEAK,
  RSTVPEAK,
  TEMP,
  PERIOD,
  TMODE=0x3d,
  CHKSUM,
  DIEREV
} PowerReg;

#define GAIN_V1  0x00
#define GAIN_V2	 0x20
#define GAIN_V4  0x40
#define GAIN_V8  0x60
#define GAIN_V16 0x80

#define GAIN_S05   0x00
#define GAIN_S025  0x08
#define GAIN_S0125 0x10

#define GAIN_I1  0x00
#define GAIN_I2	 0x01
#define GAIN_I4  0x02
#define GAIN_I8  0x03
#define GAIN_I16 0x04

#define DISHPF		0x0001
#define DISLPF2		0x0002
#define DISCF		0x0004
#define DISSAG		0x0008
#define ASUSPEND	0x0010
#define TEMPSEL		0x0020
#define SWRST		0x0040
#define CYCMODE		0x0080
#define	DISCH1		0x0100
#define	DISCH2		0x0200
#define	SWAP		0x0400
#define	DTRT0		0x0800
#define	DTRT1		0x1000
#define	WAVSEL0		0x2000
#define	WAVSEL1		0x4000
#define	POAM		0x8000

struct DF_Power;

void power_init ();
void power_init_channel (int channel, DF_Power *settings);
long power_getreg (int channel, int reg);
void power_putreg (int channel, int reg, long val);

void power_diag (int channel, int short_test);
